
Ruby - Bug #12478

ruby2.2.5でオブジェクトに対して def_delegatorを行うとNoMethodError undefined method `method_defined?'

が発生する。

06/10/2016 01:58 AM - jy5kisok@gmail.com (keiichi ishioka)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: 2.2.5 Backport: 2.1: DONTNEED, 2.2: DONE, 2.3:

DONE

Description

再現コード

printer = String.new

printer.extend SingleForwardable

printer.def_delegator "STDOUT", :puts

# NoMethodError: undefined method `method_defined?' for "":String

原因

def_single_delegatorで "method_defined?"を行っていますが、

Moduleクラスをmix-inしていないオブジェクトの場合NoMethodErrorになる。

回避方法案

Moduleが該当オブジェクトのclassに属していない場合,該当処理をスキップする

```diff

--- /usr/local/.rbenv/versions/2.2.5/lib/ruby/2.2.0/forwardable.rb.org  2016-06-10 10:31:0

9.613979605 +0900

+++ /usr/local/.rbenv/versions/2.2.5/lib/ruby/2.2.0/forwardable.rb      2016-06-10 10:35:0

6.452506085 +0900

@@ -277,7 +277,7 @@

    accessor = accessor.to_s

    if method_defined?(accessor) || private_method_defined?(accessor)

      accessor = "#{accessor}()"

-    end if

+    end if self.class === Module

    line_no = __LINE__; str = %{

      def #{ali}(*args, &block)

```

Associated revisions

Revision b661824e75787548d47e1af649727a617a964bd4 - 06/10/2016 12:54 PM - nobu (Nobuyoshi Nakada)

forwardable.rb: fix for non-module objects

lib/forwardable.rb (Forwardable._delegator_method): extract

method generator and deal with non-module objects.

[ruby-dev:49656] [Bug #12478]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@55366 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision b661824e - 06/10/2016 12:54 PM - nobu (Nobuyoshi Nakada)
forwardable.rb: fix for non-module objects

lib/forwardable.rb (Forwardable._delegator_method): extract

method generator and deal with non-module objects.

[ruby-dev:49656] [Bug #12478]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@55366 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 1034b6d23dee1ab33e5da4f5d816b2af0cefc062 - 02/07/2017 05:18 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 53383,55366: [Backport #12478]

    * lib/forwardable.rb (def_instance_delegator): adjust backtrace of

      method body by tail call optimization.  adjusting the delegated

      target is still done by deleting backtrace.

    * lib/forwardable.rb (def_single_delegator): ditto.

    * lib/forwardable.rb (Forwardable._delegator_method): extract

      method generator and deal with non-module objects.

      [ruby-dev:49656] [Bug #12478]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@57570 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 1034b6d2 - 02/07/2017 05:18 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 53383,55366: [Backport #12478]

    * lib/forwardable.rb (def_instance_delegator): adjust backtrace of

      method body by tail call optimization.  adjusting the delegated

      target is still done by deleting backtrace.

    * lib/forwardable.rb (def_single_delegator): ditto.

    * lib/forwardable.rb (Forwardable._delegator_method): extract

      method generator and deal with non-module objects.

      [ruby-dev:49656] [Bug #12478]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@57570 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision a14ba6e3d58d6f63f47c0549f60306c4989478ba - 03/25/2017 02:43 PM - U.Nakamura 

merge revision(s) 53383,55366: [Backport #12478]

    * lib/forwardable.rb (def_instance_delegator): adjust backtrace of

      method body by tail call optimization.  adjusting the delegated

      target is still done by deleting backtrace.

    * lib/forwardable.rb (def_single_delegator): ditto.

    * lib/forwardable.rb (Forwardable._delegator_method): extract

      method generator and deal with non-module objects.

      [ruby-dev:49656] [Bug #12478]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@58085 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision a14ba6e3 - 03/25/2017 02:43 PM - U.Nakamura 

merge revision(s) 53383,55366: [Backport #12478]

    * lib/forwardable.rb (def_instance_delegator): adjust backtrace of

      method body by tail call optimization.  adjusting the delegated

      target is still done by deleting backtrace.

    * lib/forwardable.rb (def_single_delegator): ditto.

    * lib/forwardable.rb (Forwardable._delegator_method): extract

      method generator and deal with non-module objects.

      [ruby-dev:49656] [Bug #12478]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@58085 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 06/10/2016 11:19 AM - nobu (Nobuyoshi Nakada)
- Description updated

- Backport changed from 2.1: UNKNOWN, 2.2: UNKNOWN, 2.3: UNKNOWN to 2.1: DONTNEED, 2.2: REQUIRED, 2.3: REQUIRED

#2 - 06/10/2016 12:54 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset r55366.

forwardable.rb: fix for non-module objects

lib/forwardable.rb (Forwardable._delegator_method): extract

method generator and deal with non-module objects.

[ruby-dev:49656] [Bug #12478]

#3 - 02/07/2017 05:18 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.1: DONTNEED, 2.2: REQUIRED, 2.3: REQUIRED to 2.1: DONTNEED, 2.2: REQUIRED, 2.3: DONE

ruby_2_3 r57570 merged revision(s) 53383,55366.

#4 - 03/25/2017 02:43 PM - usa (Usaku NAKAMURA)

- Backport changed from 2.1: DONTNEED, 2.2: REQUIRED, 2.3: DONE to 2.1: DONTNEED, 2.2: DONE, 2.3: DONE

ruby_2_2 r58085 merged revision(s) 53383,55366.
